

package com.nantian.sc.cloud.admin.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.nantian.sc.cloud.admin.api.dto.MenuTree;
import com.nantian.sc.cloud.admin.api.entity.SysMenu;
import com.nantian.sc.cloud.admin.api.vo.MenuVO;
import com.nantian.sc.cloud.common.core.util.R;

import java.util.Collection;
import java.util.List;

/**
 * <p>
 * 菜单权限表 服务类
 * </p>
 *
 *
 * @since 2017-10-29
 */
public interface SysMenuService extends IService<SysMenu> {
	/**
	 * 通过角色编号查询URL 权限
	 *
	 * @param roleId 角色ID
	 * @return 菜单列表
	 */
	List<MenuVO> findMenuByRoleId(Integer roleId);

	/**
	 * 级联删除菜单
	 *
	 * @param id 菜单ID
	 * @return 成功、失败
	 */
	R removeMenuById(Integer id);

	/**
	 * 更新菜单信息
	 *
	 * @param sysMenu 菜单信息
	 * @return 成功、失败
	 */
	Boolean updateMenuById(SysMenu sysMenu);

	/**
	 * 根据角色编码获取权限
	 */
	List<MenuTree> findMenuTreeByRoleId(Integer roleId);

	/**
	 * 根据角色集合获取去重后的权限
	 */
	List<MenuTree> findMenuTreeByRoles(List<Integer> roles);

	boolean saveMenu(SysMenu sysMenu);

	boolean deleteMenuById(Integer id);
}
